
CoCoALib - Bug #1790

saturate with zero ideals
Status: Closed Start date: 13 Mar 2024

Priority: High Due date:  

Assignee: John Abbott % Done: 100%

Category: Maths Bugs Estimated time: 0.00 hour

Target version: CoCoALib-0.99850 Spent time: 1.30 hour

Description

The following two bugs were also present in Singular...

I := ideal(R,[]);

I:I; // --> ideal(1)

saturate(I,I); // --> ERROR

J := ideal(zero(R));

J:J; // --> ideal(1)

saturate(J,J); // --> ERROR, but a different error from above!

Related issues:

Related to CoCoALib - Slug #967: Improve saturate Resolved 10 Nov 2016

History

#1 - 13 Mar 2024 19:27 - John Abbott

It should be easy to fix these two cases.  Are there any others involving the zero ideal?

Make several tests and adjoin them to the test suite!

#2 - 13 Mar 2024 19:27 - John Abbott

- Related to Slug #967: Improve saturate added

#3 - 13 Mar 2024 20:37 - John Abbott

- Status changed from New to In Progress

- % Done changed from 0 to 10

The relevant source code is in TmpGOperations.C near line 864.

One problem is that an empty PolyList does know to which ring its elements belong, so the function ComputeSaturation cannot return ideal(1) since

it does not have the information needed to know which ring the ideal is in.

It really would be helpful to have a RingElemVector which guarantees that all its elements are in the same ring, and even knows the ring when the list

is empty!

#4 - 13 Mar 2024 20:44 - John Abbott

The code probably needs to be redesigned: we spoke about this last time, that ideals should not be modifiable, but that an operation should (almost?)

always produce a new ideal object.

#5 - 15 Mar 2024 19:25 - John Abbott

- Status changed from In Progress to Resolved

- Assignee set to John Abbott
- % Done changed from 10 to 80

The problem was that in BuiltInFunctions-CoCoALib.C there was a call to I->mySaturate(J) instead of saturate(I,J), which was not declared in ideal.H.

I have also inserted CoCoA_ASSERT in mySaturate and myColon so that the rings are checked when debugging is active.

#6 - 21 Mar 2024 13:27 - Anna Maria Bigatti

John Abbott wrote:

The problem was that in BuiltInFunctions-CoCoALib.C there was a call to I->mySaturate(J) instead of saturate(I,J), which was not declared in

ideal.H.

 

Now moved to BuiltInOneLiner-CoCoALib.C

#7 - 21 Mar 2024 17:56 - Anna Maria Bigatti

- Status changed from Resolved to Closed

- % Done changed from 80 to 100
